package ch.unibe.piccola;

import ch.unibe.piccola.code.OpCode;
import ch.unibe.piccola.vm.Agent;
import ch.unibe.piccola.vm.IAgentObserver;
import ch.unibe.piccola.vm.IChannelObserver;
import ch.unibe.piccola.vm.IObserverFactory;

/**
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Sep 30, 2002)
**/
public class LogDebuggerFactory implements IObserverFactory
{

    public IAgentObserver newAgentObserver()
    {
        return new IAgentObserver() {
            public void afterExecute(OpCode opcode)
            {
            }
            public void beforeExecute(OpCode opcode)
            {
                System.out.println(opcode);
            }
            public void onBlock(Agent agent)
            {
                System.out.println("Agent " + agent.getId() + " BLOCKS");
            }
            public void onReceive(Agent agent)
            {
                System.out.println("Agent " + agent.getId() + " RECEIVES FORM");
            }
            public void onSend(Agent agent)
            {
                System.out.println("Agent " + agent.getId() + " SENDS FORM");
            }
            public void onStart(Agent agent)
            {
                System.out.println("Agent " + agent.getId() + " STARTS");
            }
            public void onStop(Agent agent)
            {
                System.out.println("Agent " + agent.getId() + " STOPS");
            }
            public void onUnblock(Agent agent)
            {
                System.out.println("Agent " + agent.getId() + " UNBLOCKS");
            }
        };
    }

    public IChannelObserver newChannelObserver()
    {
        return null;
    }

}