package ch.unibe.piccola.bridge;

import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>CaretListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericCaretListener extends GenericListener
    implements CaretListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericCaretListener(Form handler)
    {
        m_caretUpdate = extractService(handler, "caretUpdate");
    }

    public void caretUpdate(CaretEvent event)
    {
        m_caretUpdate.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_caretUpdate;

}
