package ch.unibe.piccola.bridge;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>KeyListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericKeyListener extends GenericListener
    implements KeyListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericKeyListener(Form handler)
    {
        m_keyPressed = extractService(handler, "keyPressed");
        m_keyReleased = extractService(handler, "keyReleased");
        m_keyTyped = extractService(handler, "keyTyped");
    }

    public void keyPressed(KeyEvent event)
    {
		m_keyPressed.callback(this, event);
    }

    public void keyReleased(KeyEvent event)
    {
        m_keyReleased.callback(this, event);
    }

    public void keyTyped(KeyEvent event)
    {
        m_keyTyped.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_keyPressed;

    private final Service m_keyReleased;

    private final Service m_keyTyped;

}
