package ch.unibe.piccola.bridge;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>MouseListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericMouseListener extends GenericListener
    implements MouseListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericMouseListener(Form handler)
    {
        m_mouseClicked = extractService(handler, "mouseClicked");
        m_mouseEntered = extractService(handler, "mouseEntered");
        m_mouseExited = extractService(handler, "mouseExited");
        m_mousePressed = extractService(handler, "mousePressed");
        m_mouseReleased = extractService(handler, "mouseReleased");
    }

    public void mouseClicked(MouseEvent event)
    {
        m_mouseClicked.callback(this, event);
    }

    public void mouseEntered(MouseEvent event)
    {
        m_mouseEntered.callback(this, event);
    }

    public void mouseExited(MouseEvent event)
    {
        m_mouseExited.callback(this, event);
    }

    public void mousePressed(MouseEvent event)
    {
        m_mousePressed.callback(this, event);
    }

    public void mouseReleased(MouseEvent event)
    {
        m_mouseReleased.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_mouseClicked;

    private final Service m_mouseEntered;

    private final Service m_mouseExited;

    private final Service m_mousePressed;

    private final Service m_mouseReleased;

}
