package ch.unibe.piccola.bridge;

import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>MouseMotionListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericMouseMotionListener extends GenericListener
    implements MouseMotionListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericMouseMotionListener(Form handler)
    {
        m_mouseDragged = extractService(handler, "mouseDragged");
        m_mouseMoved = extractService(handler, "mouseMoved");
    }

    public void mouseDragged(MouseEvent event)
    {
        m_mouseDragged.callback(this, event);
    }

    public void mouseMoved(MouseEvent event)
    {
        m_mouseMoved.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_mouseDragged;

    private final Service m_mouseMoved;

}
