package ch.unibe.piccola.bridge;

import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>TreeExpansionListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericTreeExpansionListener extends GenericListener
    implements TreeExpansionListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericTreeExpansionListener(Form handler)
    {
        m_treeCollapsed = extractService(handler, "treeCollapsed");
        m_treeExpanded = extractService(handler, "treeExpanded");
    }

    public void treeCollapsed(TreeExpansionEvent event)
    {
        m_treeCollapsed.callback(this, event);
    }

    public void treeExpanded(TreeExpansionEvent event)
    {
        m_treeExpanded.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_treeCollapsed;

    private final Service m_treeExpanded;

}
