package ch.unibe.piccola.bridge;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import ch.unibe.piccola.vm.Form;
import ch.unibe.piccola.vm.Service;

/**
 * Implements a generic <code>WindowListener</code>.
 *
 * @author   Stefan Kneubuehl
 * @version  4.0 (Jun 09, 2003)
**/
public class GenericWindowListener extends GenericListener
    implements WindowListener
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public GenericWindowListener(Form handler)
    {
        m_windowActivated = extractService(handler, "windowActivated");
        m_windowClosed = extractService(handler, "windowClosed");
        m_windowClosing = extractService(handler, "windowClosing");
        m_windowDeactivated = extractService(handler, "windowDeactivated");
        m_windowDeiconified = extractService(handler, "windowDeiconified");
        m_windowIconified = extractService(handler, "windowIconified");
        m_windowOpened = extractService(handler, "windowOpened");
    }

    public void windowActivated(WindowEvent event)
    {
        m_windowActivated.callback(this, event);
    }

    public void windowClosed(WindowEvent event)
    {
        m_windowClosed.callback(this, event);
    }

    public void windowClosing(WindowEvent event)
    {
        m_windowClosing.callback(this, event);
    }

    public void windowDeactivated(WindowEvent event)
    {
        m_windowDeactivated.callback(this, event);
    }

    public void windowDeiconified(WindowEvent event)
    {
        m_windowDeiconified.callback(this, event);
    }

    public void windowIconified(WindowEvent event)
    {
        m_windowIconified.callback(this, event);
    }

    public void windowOpened(WindowEvent event)
    {
        m_windowOpened.callback(this, event);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Service m_windowActivated;

    private final Service m_windowClosed;

    private final Service m_windowClosing;

    private final Service m_windowDeactivated;

    private final Service m_windowDeiconified;

    private final Service m_windowIconified;

    private final Service m_windowOpened;

}
