package ch.unibe.piccola.bytecode;

import org.apache.bcel.Constants;
import org.apache.bcel.generic.ClassGen;
import org.apache.bcel.generic.FieldGen;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.Type;

/**
 * @author  $Id: FieldFactory.java,v 3.5 2003/01/10 13:46:25 kneubuhl Exp $
**/

public class FieldFactory implements Constants, FactoryConstants {

	private ClassGen m_classGen;

	public FieldFactory(ClassGen cg) {
		m_classGen = cg;
	}

    public ClassGen addField(String fieldName) {
		ConstantPoolGen cp = m_classGen.getConstantPool();	
		FieldGen fg = new FieldGen(ACC_PRIVATE, m_IFormObjectType, fieldName, cp);
		m_classGen.addField(fg.getField());
		return m_classGen;
    }

	public ClassGen addField(FieldDeclaration fieldDeclaration) {
		ConstantPoolGen cp = m_classGen.getConstantPool();
		
		int bcelModifiers =	TypeConverter.java2bcelModifiers(fieldDeclaration.getModifiers());
		Type bcelType = TypeConverter.class2bcelType(fieldDeclaration.getType());
		String fieldName = fieldDeclaration.getName();
		
		FieldGen fg = new FieldGen(bcelModifiers, bcelType, fieldName, cp);
		m_classGen.addField(fg.getField());
		return m_classGen;
	}
}
