package ch.unibe.piccola.bytecode;

import org.apache.bcel.generic.ClassGen;

import java.util.ArrayList;
import java.lang.reflect.Method;

/**
 * @author  $Id: InterfaceFactory.java,v 3.5 2003/01/10 13:46:27 kneubuhl Exp $
**/

public class InterfaceFactory extends AbstractFactory {

    public ClassGen implementInterface(String className, String superClassName, ArrayList interfaceNameList) {
		ArrayList methodDeclarationList = new ArrayList();
		for (int i=0; i<interfaceNameList.size(); i++) {
			ArrayList methodList = getMethodsOfClassOrInterface((String)interfaceNameList.get(i));
			for (int j=0; j<methodList.size(); j++) {
				methodDeclarationList.add(new MethodDeclaration((Method) methodList.get(j)));
			}
		}
		
		int bcelModifiers = calculateAccessModifiers((String) interfaceNameList.get(0));
		ClassGen cg = createClass(className, superClassName, interfaceNameList, bcelModifiers, null, methodDeclarationList);
		
		return cg;
	}
	
	protected int calculateAccessModifiers(String className) {
    	Class aClass = TypeConverter.getClass(className);
		int bcelModifiers = TypeConverter.java2bcelModifiers(aClass.getModifiers());
		// Turn an abstract class into a concrete class
	    bcelModifiers = (bcelModifiers ^ ACC_ABSTRACT ^ ACC_INTERFACE);
		return bcelModifiers;
	}

}

