package ch.unibe.piccola.bytecode;

import java.util.ArrayList;
import java.lang.reflect.Method;

// java.lang.reflect.Method is read only

/**
 * @author  $Id: MethodDeclaration.java,v 3.5 2003/01/10 13:46:27 kneubuhl Exp $
**/

public class MethodDeclaration extends AbstractDeclaration{
	final private Class m_returnType;
	final private Class[] m_parameterTypes;

	public MethodDeclaration(String name, int modifiers, Class returnType, ArrayList parameterTypeList) {
		m_name = name;
		m_modifiers = modifiers;
		m_returnType = returnType;
		m_parameterTypes = new Class[parameterTypeList.size()];
		for (int i=0; i<parameterTypeList.size(); i++) {
			m_parameterTypes[i] = (Class) parameterTypeList.get(i);
		}
	}
	
	public MethodDeclaration(Method method) {
		m_name = method.getName();
		m_modifiers = method.getModifiers();
		m_returnType = method.getReturnType();
		m_parameterTypes = method.getParameterTypes();	
	}

	public Class getReturnType() {
		return m_returnType;
	}

	public Class[] getParameterTypes() {
		return m_parameterTypes;
	}

	public String toString() { 
		StringBuffer strBuf = new StringBuffer();
		strBuf.append("Name:        ").append(m_name);
		strBuf.append("\nModifiers:   ").append(m_modifiers);
		strBuf.append("\nReturn Type: ").append(m_returnType.getName());
		if (0 == m_parameterTypes.length) {
			strBuf.append("\nNo Argument Type\n");
		} else {
			strBuf.append("\nArgumentType:\n");
			for (int i=0; i< m_parameterTypes.length; i++) {
				strBuf.append("  ").append(m_parameterTypes[i].getName());
			}
		}
		return strBuf.toString();
	}
		
}
