package ch.unibe.piccola.bytecode;

import org.apache.bcel.generic.ClassGen;

import java.util.ArrayList;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

/**
 * @author  $Id: SubClassFactory.java,v 3.5 2003/01/10 13:46:28 kneubuhl Exp $
**/

public class SubClassFactory extends AbstractFactory {

	public ClassGen generateSubclass(String className, String superClassName) {	

		/* We overwrite all methods of the direct subclass only
		 * -> We select the methods of the direct subclass into an array.
         * 
         * Put we must be careful not to select final or native methods
		 */

		ArrayList superClassMethods = getMethodsOfClassOrInterface(superClassName);

		Class aClass = TypeConverter.getClass(superClassName);

 		ArrayList methodDeclarationList = new ArrayList();
		for (int i=0; i<superClassMethods.size(); i++) {
			Method method = (Method) superClassMethods.get(i);
			if (method.getDeclaringClass() == aClass &&
                (!(Modifier.isStatic(method.getModifiers()))) &&  //FIXME
                (!(Modifier.isFinal(method.getModifiers()))) &&
                (!(Modifier.isNative(method.getModifiers())))) {
				methodDeclarationList.add(new MethodDeclaration(method));
			}
		}
		
		int bcelModifiers = calculateAccessModifiers(superClassName);
		ClassGen cg = createClass(className, superClassName, null, bcelModifiers, null, methodDeclarationList);

		return cg;
	}

	protected int calculateAccessModifiers(String className) {
	   	Class aClass = TypeConverter.getClass(className);
		int bcelModifiers = TypeConverter.java2bcelModifiers(aClass.getModifiers());
		// Turn an abstract class into a concrete class
		if (Modifier.isAbstract(aClass.getModifiers())) {
			bcelModifiers = (bcelModifiers ^ ACC_ABSTRACT);
		}
		return bcelModifiers;
	}

}

