package ch.unibe.piccola.code;

/**
 * The base class for an external Piccola services.
 *
 * @author   Stefan Kneubuehl
 * @version  3.6c (May 11, 2003)
**/
public abstract class JavaOp
{

    /**
     * Executes this service with the specified arguments on the specified
     * target.
     *
     * @param  target the target of the service call.
     * @param  args the arguments for the call.
     * @return the return value of the service call.
    **/
    public abstract Object call(Object target, Arguments args);

    /**
     * Compares this Piccola service with the specified object.
     *
     * @param  object the object to be compared with this service.
    **/
    public boolean equals(Object object)
    {
        return this == object;
    }

    public abstract int hashCode();

    /**
     * Returns a string representation of this service.
     *
     * @return a string representation of this service.
    **/
    public abstract String toString();

}
