package ch.unibe.piccola.code;

import ch.unibe.piccola.source.SourceRef;;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 10, 2002)
**/
class OpBind extends OpCode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public final boolean equals(Object object)
    {
        if (!super.equals(object)) {
            return false;
        }
        return m_label.equals(((OpBind) object).m_label);
    }

    public final void execute(IVM vm)
    {
        vm.opBind(m_label);
    }

    public final String toString()
    {
        return "OpBind(" + m_label + ")";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    OpBind(SourceRef sourceRef, String label)
    {
        super(sourceRef);
        m_label = label;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final String m_label;

}