package ch.unibe.piccola.code;

import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Aug 08, 2002)
**/
class OpService extends OpCode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public final boolean equals(Object object)
    {
        if (!super.equals(object)) {
            return false;
        }
        OpService other = (OpService) object;
        return m_code.equals(other.m_code);
    }

    public final void execute(IVM vm)
    {
        vm.opService(m_code);
    }

    public final String toString()
    {
        return "OpService(" + m_code + ")";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    OpService(SourceRef sourceRef, Code code)
    {
        super(sourceRef);
        m_code = code;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Code m_code;

}