/* Generated By:JavaCC: Do not edit this line. ParserImpl.java */
package ch.unibe.piccola.parser.javacc;

// WARNING:
// after generating a new parser, i.e. by running 'javacc Parser.jj'
// the following changes must be done:
// 1) in JCCParser.java:
//    replace the 5 occurrences of 'JCCParserTokenManager' by 'Scanner'
// 2) in JCCParserTokenManager.java:
//    insert in method 'jjFillToken()' the line:
//         t.m_beginPos = input_stream.getBeginPos();
//

import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import ch.unibe.piccola.syntax.Node;
import ch.unibe.piccola.syntax.SyntaxFactory;
import ch.unibe.piccola.source.SourceCode;
import ch.unibe.piccola.source.SourceRef;


/**
 * @author    Stefan Kneubuehl
 * @version   3.4c (Oct 02, 2002)
**/
public class ParserImpl implements ParserImplConstants {

    private static SyntaxFactory factory = SyntaxFactory.INSTANCE;

    public void setSource(SourceCode source)
    {
        m_source = source;
    }

    private String[] tokensToStrings(ArrayList tokens)
    {
        String[] strings = new String[tokens.size()];
        Iterator e = tokens.iterator();
        int i = 0;
        while (e.hasNext()) {
            Token token = (Token) e.next();
            strings[i] = null == token ? "" : token.toString();
            ++i;
        }
        return strings;
    }

    private SourceRef sc(Node begin, Node end)
    {
        return new SourceRef(begin.getSourceRef(), end.getSourceRef());
    }

    private SourceRef sc(Node begin, Token end)
    {
        return new SourceRef(begin.getSourceRef(), end.getEndPos(), end.endLine, end.endColumn);
    }

    private SourceRef sc(Token begin, Node end)
    {
        return new SourceRef(begin.m_beginPos, begin.beginLine, begin.beginColumn, end.getSourceRef());
    }

    private SourceRef sc(Token begin, Token end)
    {
        return new SourceRef(m_source,
            begin.m_beginPos, begin.beginLine, begin.beginColumn,
            end.getEndPos(), end.endLine, end.endColumn);
    }

    private Node makeAbstraction(Token backslash, ArrayList params, Node form)
    {
        String[] p = tokensToStrings(params);
        if (p.length == 1) {
            return factory.newAbstraction(sc(backslash, form),
                form, p[0]);
        }
        return factory.newCurriedAbstraction(sc(backslash, form), form, p);
    }

    private Node makeApplication(Node functor, Node argument)
    {
        return factory.newApplication(sc(functor, argument), functor, argument);
    }

    private Node makeCollection(Token left, Statement[] stmts, Token right)
    {
        ArrayList vec = new ArrayList();

        if (null != stmts) {
            for (int i = 0; i < stmts.length; ++i) {
                vec.add(stmts[i].getNode());
            }
        }
        Node[] children = (Node[]) vec.toArray(new Node[vec.size()]);
        return factory.newCollection(sc(left, right), children, left.image, right.image);
    }

    private Node makeInfixApplication(Node left, Token operator, Node right)
    {
        return factory.newInfixApplication(sc(left, right),
                                    left, right, operator.image);
    }

    private Node makeLabel(Token label)
    {
        return factory.newLabel(sc(label, label), label.image);
    }

    private Node makeLiteral(Token literal)
    {
        return factory.newConstant(
            sc(literal, literal), LiteralParser.parse(literal.image)
        );
    }

    private Node makeParantheses(Token left, Node form, Token right)
    {
        if (null == form) {
            return factory.newEmpty(sc(left, right));
        }
        else {
            return form;
        }
    }

    private Node makePrefixApplication(Token operator, Node child)
    {
        return factory.newPrefixApplication(sc(operator, child),
                                     child, operator.image);
    }

    private Node makeProjection(Node form, Token label)
    {
        return factory.newProjection(sc(form, label), form, label.image);
    }

    private Node makeRoot(Token root)
    {
        return factory.newRoot(sc(root, root));
    }

    private SourceCode m_source;

// ----------------------------------------------------------------------------
// Parse script
// ----------------------------------------------------------------------------
  final public Node script() throws ParseException {
    Node frm;
    frm = form();
    jj_consume_token(0);
          {if (true) return frm;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse form
// ----------------------------------------------------------------------------
  final public Node form() throws ParseException {
    Statement[] stmts;
    Node node;
    stmts = statements();
            node = stmts[stmts.length - 1].getNode();
            for (int i = stmts.length - 2; i >= 0; --i) {
                node = stmts[i].extend(node);
            }
            {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse statements
// ----------------------------------------------------------------------------
  final public Statement[] statements() throws ParseException {
    ArrayList vec = new ArrayList();
    Statement stmt;
    stmt = statement();
          vec.add(stmt);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      jj_consume_token(COMMA);
      stmt = statement();
              vec.add(stmt);
    }
          {if (true) return (Statement[]) vec.toArray(new Statement[vec.size()]);}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse statement (2R precedence)
// ----------------------------------------------------------------------------
  final public Statement statement() throws ParseException {
    Token token = null;
    Statement stmt;
    Node frm;
    ArrayList lbl;
    ArrayList par;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case BACKSLASH:
      // anonymous service
          token = jj_consume_token(BACKSLASH);
      par = params();
      stmt = statement();
            {if (true) return new Statement(
                makeAbstraction(token, par, stmt.getNode())
            );}
      break;
    default:
      jj_la1[3] = jj_gen;
      if (jj_2_1(2147483647)) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DEF:
          token = jj_consume_token(DEF);
          break;
        default:
          jj_la1[1] = jj_gen;
          ;
        }
        lbl = labels();
        jj_consume_token(EQUAL);
        stmt = statement();
          {if (true) return new BindingStatement(token, lbl, stmt);}
      } else if (jj_2_2(2147483647)) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DEF:
          token = jj_consume_token(DEF);
          break;
        default:
          jj_la1[2] = jj_gen;
          ;
        }
        lbl = labels();
        par = params();
        stmt = statement();
          {if (true) return new NamedAbstractionStatement(token, lbl, par, stmt);}
      } else if (jj_2_3(2147483647)) {
        token = jj_consume_token(ROOT);
        jj_consume_token(EQUAL);
        stmt = statement();
          {if (true) return new SandboxStatement(token, stmt);}
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case QUOTE:
          // quote
              token = jj_consume_token(QUOTE);
          stmt = statement();
          {if (true) return new QuoteStatement(token, stmt);}
          break;
        case LEFT:
        case ROOT:
        case TIGHTLEFT:
        case NUMBER:
        case STRING:
        case MULTILINESTRING:
        case OP4:
        case OP3:
        case OP2:
        case OP1:
        case IDENTIFIER:
        case LPAREN:
        case TIGHTLPAREN:
          frm = invocation();
          {if (true) return new Statement(frm);}
          break;
        default:
          jj_la1[4] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    }
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse invocation (3L precedence)
// ----------------------------------------------------------------------------
  final public Node invocation() throws ParseException {
    Node frm;
    Node arg;
    frm = otherInfix();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFT:
      case ROOT:
      case TIGHTLEFT:
      case NUMBER:
      case STRING:
      case MULTILINESTRING:
      case OP4:
      case OP3:
      case OP2:
      case OP1:
      case IDENTIFIER:
      case LPAREN:
      case TIGHTLPAREN:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_2;
      }
      arg = otherInfix();
              frm = makeApplication(frm, arg);
    }
      {if (true) return frm;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse other infix operators (4L precedence)
// ----------------------------------------------------------------------------
  final public Node otherInfix() throws ParseException {
    Node lha;
    Node rha;
    Token op;
    lha = comparison();
    label_3:
    while (true) {
      if (jj_2_4(2)) {
        ;
      } else {
        break label_3;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OP1:
        op = jj_consume_token(OP1);
        break;
      case BACKQUOTEIDENTIFIER:
        op = jj_consume_token(BACKQUOTEIDENTIFIER);
        break;
      default:
        jj_la1[6] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      rha = comparison();
              lha = makeInfixApplication(lha, op, rha);
    }
      {if (true) return lha;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse comparison operators (5L precedence)
// ----------------------------------------------------------------------------
  final public Node comparison() throws ParseException {
    Node lha;
    Node rha;
    Token op;
    lha = arithmeticLow();
    label_4:
    while (true) {
      if (jj_2_5(2)) {
        ;
      } else {
        break label_4;
      }
      op = jj_consume_token(OP2);
      rha = arithmeticLow();
              lha = makeInfixApplication(lha, op, rha);
    }
      {if (true) return lha;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse arithmetic low operators (6L precedence)
// ----------------------------------------------------------------------------
  final public Node arithmeticLow() throws ParseException {
    Node lha;
    Node rha;
    Token op;
    lha = arithmeticHigh();
    label_5:
    while (true) {
      if (jj_2_6(2)) {
        ;
      } else {
        break label_5;
      }
      op = jj_consume_token(OP3);
      rha = arithmeticHigh();
              lha = makeInfixApplication(lha, op, rha);
    }
      {if (true) return lha;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse arithmetic high operators (7L precedence)
// ----------------------------------------------------------------------------
  final public Node arithmeticHigh() throws ParseException {
    Node lha;
    Node rha;
    Token op;
    lha = formTight();
    label_6:
    while (true) {
      if (jj_2_7(2)) {
        ;
      } else {
        break label_6;
      }
      op = jj_consume_token(OP4);
      rha = formTight();
              lha = makeInfixApplication(lha, op, rha);
    }
      {if (true) return lha;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse projection and tight invocation (8L precedence)
// ----------------------------------------------------------------------------
  final public Node formTight() throws ParseException {
    Node frm;
    Node inner = null;
    Statement[] stmts = null;
    Token left;
    Token right;
    Token id;
    frm = prefix();
    label_7:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
      case TIGHTLEFT:
      case TIGHTLPAREN:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_7;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        jj_consume_token(DOT);
        id = jj_consume_token(IDENTIFIER);
                frm = makeProjection(frm, id);
        break;
      case TIGHTLEFT:
      case TIGHTLPAREN:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case TIGHTLEFT:
          left = jj_consume_token(TIGHTLEFT);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case BACKSLASH:
          case DEF:
          case LEFT:
          case QUOTE:
          case ROOT:
          case TIGHTLEFT:
          case NUMBER:
          case STRING:
          case MULTILINESTRING:
          case OP4:
          case OP3:
          case OP2:
          case OP1:
          case IDENTIFIER:
          case LPAREN:
          case TIGHTLPAREN:
            inner = form();
            break;
          default:
            jj_la1[8] = jj_gen;
            ;
          }
          right = jj_consume_token(RIGHT);
                        frm = makeApplication(frm,
                              makeParantheses(left, inner, right));
                        inner = null;
          break;
        case TIGHTLPAREN:
          left = jj_consume_token(TIGHTLPAREN);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case BACKSLASH:
          case DEF:
          case LEFT:
          case QUOTE:
          case ROOT:
          case TIGHTLEFT:
          case NUMBER:
          case STRING:
          case MULTILINESTRING:
          case OP4:
          case OP3:
          case OP2:
          case OP1:
          case IDENTIFIER:
          case LPAREN:
          case TIGHTLPAREN:
            stmts = statements();
            break;
          default:
            jj_la1[9] = jj_gen;
            ;
          }
          right = jj_consume_token(RPAREN);
                        frm = makeApplication(frm,
                              makeCollection(left, stmts, right));
          break;
        default:
          jj_la1[10] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[11] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
          {if (true) return frm;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse prefix operators (9R precedence)
// ----------------------------------------------------------------------------
  final public Node prefix() throws ParseException {
    Token op;
    Node frm;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case OP4:
    case OP3:
    case OP2:
    case OP1:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case OP1:
        op = jj_consume_token(OP1);
        break;
      case OP2:
        op = jj_consume_token(OP2);
        break;
      case OP3:
        op = jj_consume_token(OP3);
        break;
      case OP4:
        op = jj_consume_token(OP4);
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      frm = prefix();
          {if (true) return makePrefixApplication(op, frm);}
      break;
    case LEFT:
    case ROOT:
    case TIGHTLEFT:
    case NUMBER:
    case STRING:
    case MULTILINESTRING:
    case IDENTIFIER:
    case LPAREN:
    case TIGHTLPAREN:
      frm = atom();
              {if (true) return frm;}
      break;
    default:
      jj_la1[13] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse atoms according to
//
// Form     ::= cleft [FormList] cright                   Collection
//            | identifier                                Label
//            | literal                                   Literal
//            | "(" Form ")"                              Parantheses
//            | "root"                                    Static Namespace
// ----------------------------------------------------------------------------
  final public Node atom() throws ParseException {
    Token token;
    Token left;
    Token right;
    Node frm = null;
    Statement[] stmts = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
    case TIGHTLPAREN:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        left = jj_consume_token(LPAREN);
        break;
      case TIGHTLPAREN:
        left = jj_consume_token(TIGHTLPAREN);
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BACKSLASH:
      case DEF:
      case LEFT:
      case QUOTE:
      case ROOT:
      case TIGHTLEFT:
      case NUMBER:
      case STRING:
      case MULTILINESTRING:
      case OP4:
      case OP3:
      case OP2:
      case OP1:
      case IDENTIFIER:
      case LPAREN:
      case TIGHTLPAREN:
        stmts = statements();
        break;
      default:
        jj_la1[15] = jj_gen;
        ;
      }
      right = jj_consume_token(RPAREN);
          {if (true) return makeCollection(left, stmts, right);}
      break;
    case IDENTIFIER:
      token = jj_consume_token(IDENTIFIER);
          {if (true) return makeLabel(token);}
      break;
    case NUMBER:
    case STRING:
    case MULTILINESTRING:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NUMBER:
        token = jj_consume_token(NUMBER);
        break;
      case STRING:
        token = jj_consume_token(STRING);
        break;
      case MULTILINESTRING:
        token = jj_consume_token(MULTILINESTRING);
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
          {if (true) return makeLiteral(token);}
      break;
    case LEFT:
    case TIGHTLEFT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFT:
        left = jj_consume_token(LEFT);
        break;
      case TIGHTLEFT:
        left = jj_consume_token(TIGHTLEFT);
        break;
      default:
        jj_la1[17] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BACKSLASH:
      case DEF:
      case LEFT:
      case QUOTE:
      case ROOT:
      case TIGHTLEFT:
      case NUMBER:
      case STRING:
      case MULTILINESTRING:
      case OP4:
      case OP3:
      case OP2:
      case OP1:
      case IDENTIFIER:
      case LPAREN:
      case TIGHTLPAREN:
        frm = form();
        break;
      default:
        jj_la1[18] = jj_gen;
        ;
      }
      right = jj_consume_token(RIGHT);
          {if (true) return makeParantheses(left, frm, right);}
      break;
    case ROOT:
      token = jj_consume_token(ROOT);
          {if (true) return makeRoot(token);}
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse labels according to
//
// Labels   ::= [("root" | "dynamic") "."] identifier     Simple Label
//            | Label "." identifier                      Nested Label
// ----------------------------------------------------------------------------
  final public ArrayList labels() throws ParseException {
    ArrayList vec = new ArrayList();
    Token identifier;
    Token root = null;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ROOT:
      root = jj_consume_token(ROOT);
      jj_consume_token(DOT);
      break;
    default:
      jj_la1[20] = jj_gen;
      ;
    }
    identifier = jj_consume_token(IDENTIFIER);
            if (null != root) {
                vec.add(root);
            }
            vec.add(identifier);
    label_8:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DOT:
        ;
        break;
      default:
        jj_la1[21] = jj_gen;
        break label_8;
      }
      jj_consume_token(DOT);
      identifier = jj_consume_token(IDENTIFIER);
              vec.add(identifier);
    }
          {if (true) return vec;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parse params according to
//
// Params   ::= ":"                                       Empty Param
//            | identifier Params                         Ident Param
//            | "(" [identifier] ")" Params               Old-Style Param
// ----------------------------------------------------------------------------
  final public ArrayList params() throws ParseException {
    ArrayList vec = new ArrayList();
    Token identifier = null;
    label_9:
    while (true) {
      if (jj_2_8(2)) {
        ;
      } else {
        break label_9;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        identifier = jj_consume_token(IDENTIFIER);
                  vec.add(identifier); identifier = null;
        break;
      case LEFT:
      case TIGHTLEFT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LEFT:
          jj_consume_token(LEFT);
          break;
        case TIGHTLEFT:
          jj_consume_token(TIGHTLEFT);
          break;
        default:
          jj_la1[22] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          identifier = jj_consume_token(IDENTIFIER);
          break;
        default:
          jj_la1[23] = jj_gen;
          ;
        }
        jj_consume_token(RIGHT);
                  vec.add(identifier); identifier = null;
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(COLON);
            if (0 == vec.size()) {
                vec.add(null);
            }
            {if (true) return vec;}
    throw new Error("Missing return statement in function");
  }

// ----------------------------------------------------------------------------
// Parameter lookahead
// ----------------------------------------------------------------------------
  final public void abstractionLA() throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COLON:
      jj_consume_token(COLON);
      break;
    case LEFT:
    case TIGHTLEFT:
    case IDENTIFIER:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        jj_consume_token(IDENTIFIER);
        break;
      case LEFT:
      case TIGHTLEFT:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LEFT:
          jj_consume_token(LEFT);
          break;
        case TIGHTLEFT:
          jj_consume_token(TIGHTLEFT);
          break;
        default:
          jj_la1[25] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          jj_consume_token(IDENTIFIER);
          break;
        default:
          jj_la1[26] = jj_gen;
          ;
        }
        jj_consume_token(RIGHT);
        break;
      default:
        jj_la1[27] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      abstractionLA();
      break;
    default:
      jj_la1[28] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  final private boolean jj_3R_27() {
    if (jj_scan_token(LEFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_21() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_27()) {
    jj_scanpos = xsp;
    if (jj_3R_28()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_29()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RIGHT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_3R_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_37() {
    if (jj_scan_token(OP1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_5() {
    if (jj_scan_token(OP2)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_17()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_26() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_32()) {
    jj_scanpos = xsp;
    if (jj_3R_33()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_32() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_37()) {
    jj_scanpos = xsp;
    if (jj_3R_38()) {
    jj_scanpos = xsp;
    if (jj_3R_39()) {
    jj_scanpos = xsp;
    if (jj_3R_40()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_15() {
    if (jj_scan_token(BACKQUOTEIDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_8() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_20()) {
    jj_scanpos = xsp;
    if (jj_3R_21()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_16() {
    if (jj_3R_17()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_14() {
    if (jj_scan_token(OP1)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_14()) {
    jj_scanpos = xsp;
    if (jj_3R_15()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_16()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_51() {
    if (jj_scan_token(MULTILINESTRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_scan_token(ROOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_3R_26()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_22()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_23()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_50() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_53() {
    if (jj_scan_token(TIGHTLEFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_48() {
    if (jj_scan_token(TIGHTLPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_40() {
    if (jj_scan_token(OP4)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_7() {
    if (jj_scan_token(OP4)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_19()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_46() {
    if (jj_scan_token(ROOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_scan_token(ROOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_52() {
    if (jj_scan_token(LEFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_35() {
    if (jj_scan_token(TIGHTLEFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_45() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_52()) {
    jj_scanpos = xsp;
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_49() {
    if (jj_scan_token(NUMBER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_scan_token(DEF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_3R_19()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_44() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_49()) {
    jj_scanpos = xsp;
    if (jj_3R_50()) {
    jj_scanpos = xsp;
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_12()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_13()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_43() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_10() {
    if (jj_scan_token(DEF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_10()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_scan_token(LEFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_47() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_39() {
    if (jj_scan_token(OP3)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_42() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_47()) {
    jj_scanpos = xsp;
    if (jj_3R_48()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_41() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_42()) {
    jj_scanpos = xsp;
    if (jj_3R_43()) {
    jj_scanpos = xsp;
    if (jj_3R_44()) {
    jj_scanpos = xsp;
    if (jj_3R_45()) {
    jj_scanpos = xsp;
    if (jj_3R_46()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_31() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_34()) {
    jj_scanpos = xsp;
    if (jj_3R_35()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_36()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RIGHT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_6() {
    if (jj_scan_token(OP3)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_25() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_30()) {
    jj_scanpos = xsp;
    if (jj_3R_31()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_13()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_24()) {
    jj_scanpos = xsp;
    if (jj_3R_25()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_28() {
    if (jj_scan_token(TIGHTLEFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_38() {
    if (jj_scan_token(OP2)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_17() {
    if (jj_3R_18()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public Scanner token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[29];
  final private int[] jj_la1_0 = {0x80,0x100,0x100,0x20,0x83e6d800,0x83e6c800,0x2000000,0x8200,0x83e6d920,0x83e6d920,0x8000,0x8200,0x3c00000,0x83e6c800,0x0,0x83e6d920,0x260000,0x8800,0x83e6d920,0x8026c800,0x4000,0x200,0x8800,0x80000000,0x80008800,0x8800,0x80000000,0x80008800,0x80008840,};
  final private int[] jj_la1_1 = {0x0,0x0,0x0,0x0,0x480,0x480,0x200,0x400,0x480,0x480,0x400,0x400,0x0,0x480,0x480,0x480,0x0,0x0,0x480,0x480,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  final private JJCalls[] jj_2_rtns = new JJCalls[8];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public ParserImpl(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new Scanner(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ParserImpl(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new Scanner(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ParserImpl(Scanner tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(Scanner tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 29; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[43];
    for (int i = 0; i < 43; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 29; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 43; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 8; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
