package ch.unibe.piccola.parser.javacc;

import ch.unibe.piccola.syntax.Node;
import ch.unibe.piccola.source.SourceRef;

/**
 * @author    Stefan Kneubuehl
 * @version   3.4c (Oct 02, 2001)
**/
class SandboxStatement extends Statement
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public SandboxStatement(Token root, Statement stmt)
    {
        super(stmt.getNode());
        m_root = root;
    }

    public Node extend(Node s)
    {
        return makeSandbox(s);
    }

    public Node getNode()
    {
        return makeSandbox(null);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Token m_root;

    private Node makeSandbox(Node s)
    {
        if (null == s) {
            s = sf.newEmpty(super.getNode().getSourceRef());
        }
        SourceRef sc = new SourceRef(m_root.m_beginPos, m_root.beginLine,
            m_root.beginColumn, s.getSourceRef()
        );
        return sf.newSandbox(sc, super.getNode(), s);
    }

}