package ch.unibe.piccola.source;

import java.io.IOException;
import java.io.Reader;

/**
 * This class represents Piccola source code.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 02, 2002)
**/
public abstract class SourceCode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Creates a new Reader reading the source code.
     *
     * @return a new Reader reading the source code.
     * @throws IOException if an I/O error occurs while creating the Reader.
    **/
    public abstract Reader newReader() throws IOException;

    /**
     * Returns a debug string representation of this source code.
     *
     * @return a debug string representation of this source code.
    **/
    public abstract String toString();

}