package ch.unibe.piccola.syntax;

import ch.unibe.piccola.source.SourceRef;

/**
 * Represents an application syntax node.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Nov 14, 2002)
**/
public class Application extends TwoChildrenNode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Accepts a node visitor.
     *
     * @param  visitor the node visitor to be accepted.
     *
     * @return the result of the visitor's visitApplication method.
    **/
    public Object accept(NodeVisitor visitor)
    {
        return visitor.visitApplication(this);
    }

    /**
     * Returns a debug string representation of this application node.
     *
     * @return a debug string representation of this application node.
    **/
    public String toString()
    {
        return "Application" + super.toString();
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    Application(SourceRef sourceRef, Node leftChild, Node rightChild)
    {
        super(sourceRef, leftChild, rightChild);
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected Node newInstance(Node leftChild, Node rightChild)
    {
        return new Application(getSourceRef(), leftChild, rightChild);
    }

}