package ch.unibe.piccola.syntax;

import ch.unibe.piccola.source.SourceRef;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Nov 14, 2002)
**/
public class Extension extends TwoChildrenNode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Accepts a node visitor.
     *
     * @param  visitor the node visitor to be accepted.
     *
     * @return the result of the visitor's visitExtension method.
    **/
    public Object accept(NodeVisitor visitor)
    {
        return visitor.visitExtension(this);
    }

    /**
     * Returns a debug string representation of this extension node.
     *
     * @return a debug string representation of this extension node.
    **/
    public String toString()
    {
        return "Extension" + super.toString();
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    Extension(SourceRef sourceRef, Node leftChild, Node rightChild)
    {
        super(sourceRef, leftChild, rightChild);
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected Node newInstance(Node leftChild, Node rightChild)
    {
        return new Extension(getSourceRef(), leftChild, rightChild);
    }

}