package ch.unibe.piccola.syntax;

import ch.unibe.piccola.source.SourceRef;

/**
 * Represents a root syntax node.
 *
 * @author   Stefan Kneubuehl
 * @version  3.4c (Nov 14, 2002)
**/
public class Root extends LeafNode
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    /**
     * Accepts a node visitor.
     *
     * @param  visitor the node visitor to be accepted.
     *
     * @return the result of the visitor's visitRoot method.
    **/
    public Object accept(NodeVisitor visitor)
    {
        return visitor.visitRoot(this);
    }

    /**
     * Returns a debug string representation of this root node.
     *
     * @return a debug string representation of this root node.
    **/
    public String toString()
    {
        return "Root";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    Root(SourceRef sourceRef)
    {
        super(sourceRef);
    }

}