package ch.unibe.piccola.vm;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Dec 02, 2002)
**/
class AgentThread extends Thread
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public synchronized Agent getAgent()
    {
        return m_agent;
    }

    public void run()
    {
        Agent agent;
        while (!isAborted()) {
            agent = getAgent();
            if (null == agent) {
                try {
                    sleep(1);
                }
                catch (InterruptedException ex) { }
            }
            else {
                while (!isAborted() && Agent.RUNNING == agent.getState()) {
                    agent.mainLoop();
                }
                m_pool.releaseThread(this);
            }
        }
        m_pool.removeThread(this);
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    AgentThread(AgentPool pool, ThreadGroup group, int number)
    {
        super(group, "Agent Thread " + number);
        m_agent = null;
        m_aborted = false;
        m_pool = pool;
        start();
    }

    synchronized void abort()
    {
        m_aborted = true;
    }

    synchronized void setAgent(Agent agent)
    {
        m_agent = agent;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Agent m_agent;

    private boolean m_aborted;

    private AgentPool m_pool;

    private synchronized boolean isAborted()
    {
        return m_aborted;
    }

}