package ch.unibe.piccola.vm;

import java.util.SortedMap;
import ch.unibe.piccola.type.ContractualType;
import ch.unibe.piccola.syntax.Syntax;

/**
 * @author   Stefan Kneubuehl
 * @version  3.6c (Apr 23, 2003)
**/
public class EmptyForm extends DefaultForm
{

    // ------------------------------------------------------------------------
    // private static
    // ------------------------------------------------------------------------

    private static final String FORM_EMPTY = Syntax.formEmpty();

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public Object down()
    {
        return null;
    }

    public boolean equals(Object object)
    {
        return this == object;
    }

    public boolean exists(String label)
    {
        return false;
    }

    public Form extend(Form form)
    {
        return form;
    }

    public boolean isEmpty()
    {
        return true;
    }

    public boolean runtimeEquals(Form form)
    {
        return this == form;
    }

    public int runtimeHashCode()
    {
        return 0;
    }

    public String runtimeToString()
    {
        return FORM_EMPTY;
    }

    public String toString()
    {
        return runtimeToString();
    }

    public ContractualType type()
    {
        return ContractualType.newEmpty();
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    EmptyForm(FormFactory factory)
    {
        super(factory);
    }

}
