package ch.unibe.piccola.vm;

import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 04, 2002)
**/
public class ExternalFormTest extends TestCase
{

    // ------------------------------------------------------------------------
    // test suite
    // ------------------------------------------------------------------------

    public ExternalFormTest(String name)
    {
        super(name);
    }

    public static TestSuite suite()
    {
        return new TestSuite(ExternalFormTest.class);
    }

    public static void main(String[] args)
    {
        junit.textui.TestRunner.run(suite());
    }

    // ------------------------------------------------------------------------
    // test environment
    // ------------------------------------------------------------------------

    public void setUp()
    {
        ff = new FormFactory();
        pool = new VMPool();
        empty = ff.emptyForm();
        hello = pool.wrap(new String("Hello"));
        one = pool.wrap(new Integer(1));
    }

    private VMPool pool;

    private FormFactory ff;

    private Form one;

    private Form hello;

    private Form empty;

    // ------------------------------------------------------------------------
    // tests
    // ------------------------------------------------------------------------

    public void testDown()
    {
        assertEquals(new String("Hello"), hello.down());
        assertEquals(new Integer(1), one.down());
    }

    public void testRuntimeEquals()
    {
        assertEquals(one, pool.wrap(new Integer(1)));
    }

}
