package ch.unibe.piccola.vm;

import ch.unibe.piccola.vm.Form;

/**
 * @author   Stefan Kneubuehl
 * @version  3.4c (Oct 06, 2002)
**/
class FormStack
{

    // ------------------------------------------------------------------------
    // private static
    // ------------------------------------------------------------------------

    private static final int INCREMENT = 32;

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public String toString()
    {
        String result = "FormStack[";
        if (m_top > -1) {
            result += m_data[0];
        }
        for (int i = 1; i <= m_top; ++i) {
            result += ", " + m_data[i];
        }
        return result + "]";
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    FormStack()
    {
        m_size = INCREMENT;
        m_data = new Form[m_size];
        m_top = -1;
    }

    final Form peek()
    {
        return m_data[m_top];
    }

    final Form pop()
    {
        return m_data[m_top--];
    }

    final void push(Form form)
    {
        ++m_top;
        if (m_top >= m_size - 1) {
            Form[] temp = new Form[m_size + INCREMENT];
            System.arraycopy(m_data, 0, temp, 0, m_size);
            m_size += INCREMENT;
            m_data = temp;
        }
        m_data[m_top] = form;
    }

    final int size()
    {
        return m_top + 1;
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private Form[] m_data;

    private int m_top;

    private int m_size;

}
