package ch.unibe.piccola.vm;

import java.util.SortedMap;

/**
 * @author   Stefan Kneubuehl
 * @version  3.6c (Apr 23, 2003)
**/
public class HideForm extends DefaultForm
{

    // ------------------------------------------------------------------------
    // public
    // ------------------------------------------------------------------------

    public boolean exists(String label)
    {
        return m_label.equals(label) ? false : m_form.exists(label);
    }

    public Form hide(String label)
    {
        return m_label.equals(label) ? this : factory().hideForm(label, this);
    }

    public boolean runtimeEquals(Form form)
    {
        return m_form.runtimeEquals(form);
    }

    public int runtimeHashCode()
    {
        return m_form.hashCode();
    }

    public String runtimeToString()
    {
        return m_form.runtimeToString();
    }

    public Service service()
    {
        return m_form.service();
    }

    // ------------------------------------------------------------------------
    // default
    // ------------------------------------------------------------------------

    HideForm(FormFactory factory, String label, Form form)
    {
        super(factory);
        m_form = form;
        m_label = label;
    }

    // ------------------------------------------------------------------------
    // protected
    // ------------------------------------------------------------------------

    protected SortedMap buildBindings()
    {
        SortedMap bindings = super.buildBindings();
        bindings.putAll(m_form.getBindings());
        bindings.remove(m_label);
        return bindings;
    }

    protected Form project(String label, Form defaultForm)
    {
        return m_label.equals(label) ? defaultForm : m_form.project(label);
    }

    // ------------------------------------------------------------------------
    // private
    // ------------------------------------------------------------------------

    private final Form m_form;

    private final String m_label;

}

